/*******************************************************************

	Binary File Transfer Class Declaration

    (c) Copyright 1992/1993 Marco Savegnago IW3FQG

*******************************************************************/

#ifndef __TBINXFER_H
#define __TBINXFER_H

/* pklib include */

#include <port/tmultipo.h>

/* stdlib include */

#include <fstream.h>

enum 	xferType { Receive, Transmit };

class TBinaryXferProtcol
{
protected:

	Boolean isRunning; // False

    xferType theXferType;

    unsigned long   fileSize;
    unsigned long   xferCount;

    Boolean xferOK;

	TStream *theStream;

    fstream *theFileStream;

    virtual Boolean write(byte *, word n);
    virtual Boolean read (byte *, word& n);

public:

    virtual char *getError() { return NULL; }

	virtual Boolean xfer() = 0;

    TBinaryXferProtcol(TStream *, fstream*, xferType);

};

#endif // !#define __TBINXFER_H
